<template>
  <div id="habit-log">
    <div class="modal-header p-2">{{ habit.name }}</div>
    <div class="no-body p-5">
      <vue-feedback-reaction v-model="feeling" />
      <h6 class="mb-2">
        {{ this.activeUserInfo.displayName.split(" ")[0] }} ơi, bạn đang nghĩ gì
        thế?
      </h6>
      <vs-textarea
        class="mb-10"
        counter="600"
        maxlength="600"
        :counter-danger.sync="counterDanger"
        v-model="text"
        rows="5"
      />
      <h6 class="mb-2">Nhật ký bằng hình ảnh</h6>
      <!-- Attachments -->
      <div class="w-full mt-2">
        <BaseFileInput v-model="images" />
      </div>
      <!-- /Attachments -->
    </div>
    <div class="modal-footer">
      <vs-button @click="onSave">Lưu</vs-button>
      <vs-button @click="$emit('close')">Hủy bỏ</vs-button>
    </div>
  </div>
</template>

<script>
import { VueFeedbackReaction } from "vue-feedback-reaction";
import BaseFileInput from "../../components/form-elements/BaseFileInput";

export default {
  components: {
    VueFeedbackReaction,
    BaseFileInput
  },
  props: {
    habit: { type: Object, required: true }
  },
  computed: {
    activeUserInfo() {
      return this.$store.state.AppActiveUser;
    }
  },
  data: () => ({
    feeling: null,
    text: "",
    counterDanger: false,
    images: []
  }),
  methods: {
    onSave() {
      const submitData = {
        text: this.text,
        feeling: parseInt(this.feeling),
        images: this.images,
        time: new Date().toISOString()
      };

      const payload = {
        habitId: this.habit._id,
        notify: this.$vs.notify,
        diary: submitData,
        callback: () => {
          this.$emit("close");
        }
      };

      this.$validator.validateAll().then(result => {
        if (result) {
          this.$store
            .dispatch("habit/addDiary", Object.assign({}, payload))
            .catch(error => {
              this.$error({ message: error.message });
            });
        }
      });
    }
  }
};
</script>

<style lang="scss">
#habit-log {
  .view-upload {
    z-index: 40000;
  }

  .con-img-upload {
    .con-input-upload,
    .img-upload {
      width: 100px;
      height: 100px;
      margin: 9px;
    }
  }
}
</style>
